Subject: RE: I am having a heck of a time - Please help. -- SOLUTION FOUND !

From: David Loesche <[email-masked]>
Date: Wed, 17 Jul 2002 08:45:09 -0700

Building Apache with EAPI, DSO enabled, mod_ssl and mm is a very simple
task. I do not know why it took so long to figure out. You simply following
the instructions in the mod_ssl install documentation (or other helpful
documents you can find these all over the web), and your up and running with
Apache - EAPI, DSO, mod_ssl, etc. running.

WRONG!  Not on Solaris 8.  It seems that if you build Apache on Solaris 2.6
with gcc 2.95 all is well.  Simply following the instructions in the mod_ssl
documentation and your done.  But it's another story if you are using
Solaris 8 (I am not sure about 7 or 9 - I do have time to try it on these).
After many hours of frustration and numerous emails I finally decided to try
every combination one-by-one to identify which one was the culprit.

Initial environment:

Solaris 8
Gcc 3.0.3
Apache 1.3.26
Mod_ssl-2.8.10-1.3.26
mm-1.1.3
openssl-0.9.6d

The only way this combination works is with -enable-rule=SHARED_CORE. This
option "forces" Apache to export the share symbols so they are available at
run time.  This takes a 5% performance hit and since the previous build did
not have it I assumed I was doing something wrong.  So I tried every
possible build configuration over and over - No change (I had to use the
SHARE_CORE rule).  I even tried this on Apache 2.0.39 and 1.3.20 (the
previous build version here of Apache).  No matter what I did I could not
get it to build the same way as the previous version. More work to do...

2nd shot:

Solaris 8
Gcc 2.95.3
Apache 1.3.26
Mod_ssl-2.8.10-1.3.26
mm-1.1.3
openssl-0.9.6d

EVENTS AND SOLUTION:

Same as above.  More work to do...

Last shot:

Solaris 8
Gcc 3.1
Apache 1.3.26
Mod_ssl-2.8.10-1.3.26
mm-1.1.3
openssl-0.9.6d

Worked just like all the documentation said it should have and everyone I
contacted told me to do (which I had spend over a week reading and trying
all these suggestions).  As it turns out, either the build from
sunfreeware.com for gcc 2.95 & 3.0.3 have an issue with the loader module,
the building of shared libraries, or gcc has an issue.  So, if any of you
have to do this make sure you have gcc 3.1 or SUN's compiler (I believe
SUN's works but did not try it - I guess I'm just stubborn). 

Later,

-----Original Message-----
From: David Loesche 
Sent: Monday, July 15, 2002 12:07 PM
To: [email-masked]'
Subject: RE: I am having a heck of a time - Please help.

I did read the referred document concerning the build phase.  I am intrigued
by the LD_LIBRARY_PATH suggestion.  What would you recommend I set it to?

-----Original Message-----
From: Boyle Owen [mailto:[email-masked]]
Sent: Monday, July 15, 2002 12:51 AM
To: [email-masked]
Subject: RE: I am having a heck of a time - Please help.

Could be to do with your version of openssl lib (check it is reasonably up
to date) or with your LD_LIBRARY_PATH environment variable..

Check out http://www.delouw.ch/linux/Apache-Compile-HOWTO/html/apache.html

for a good user's summary.

Rgds,

Owen Boyle

>-----Original Message-----
>From: David Loesche [mailto:[email-masked]]
>Sent: Freitag, 12. Juli 2002 20:12
>To: [email-masked]'
>Subject: I am having a heck of a time - Please help.
>
>
>I have poured through all the documentation I can find on
>enabling mod_ssl
>with Apache 1.3.26 but keep coming up short.  If I static link
>the mod_ssl
>it works fine but when I try to enable DSO and use it as a
>shared library I
>keep getting ap_add_config_define : referenced symbol not
>found.  I have the
>following config setup for the apache build:
>
>#!/bin/ksh
>SSL_BASE=/usr/local/ssl \
>EAPI_MM=../mm-1.1.3 \
>EAPI_MM_CORE_PATH=logs/httpd.mm \
>LIBS=/usr/lib/libC.so.5 \
>CFLAGS=-fPIC \
>./configure    --prefix=/opt/apache \
>               --enable-rule=EAPI \
>               --enable-module=ssl \
>               --enable-shared=ssl \
>               --disable-rule=SSL_COMPAT \
>               --enable-rule=SSL_SDBM \
>               --enable-suexec \
>               --suexec-caller=http
>
>I have followed the instructions in the modssl install guide to patch
>Apache.  Please verify the following build for mod_ssl:
>
>./configure    --with-apache=../apache_1.3.26 \
>               --with-ssl=/usr/local/ssl \
>               --with-mm=../mm-1.1.3
>
>If you can help (point me to some documentation) I would be
>very grateful...
>
>
>David S. Loesche
>[email-masked]                        Yipes
>Communications, Inc.
>Main:  (415) 901-2000                  114 Sansome Street, Suite 1045
>Direct:        (415) 901-2210                  San Francisco, CA 94104
>Fax:   (415) 901-2201                  http://www.yipes.com
>
>Yipes is the defining provider of fully scalable bandwidth for
>businesses.
>We offer fully managed high-speed Internet and Nationwide LAN-to-LAN
>services at speeds ranging from 1 Mbps to 1 Gbps, in 1 Mbps
>increments.
>
>Yipes delivers this uniquely flexible service over the first nationwide
>system of optical IP networks.
>
>______________________________________________________________________
>Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
>User Support Mailing List                      [email-masked]
>Automated List Manager                            [email-masked]
>
______________________________________________________________________
Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
User Support Mailing List                      [email-masked]
Automated List Manager                            [email-masked]
______________________________________________________________________
Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
User Support Mailing List                      [email-masked]
Automated List Manager                            [email-masked]
______________________________________________________________________
Apache Interface to OpenSSL (mod_ssl)                   www.modssl.org
User Support Mailing List                      [email-masked]
Automated List Manager                            [email-masked]

---

From: Steve Romero <[email-masked]>
Date: Wed, 17 Jul 2002 16:44:57 -0500

David,

yes I've encountered problems with gcc when building apache as well.  I 
don't know what the problem is I always thought it was a version issue.  I 
use a gcc-2.8.1 package from FSF, and that works.  Perhaps I should try 
compiling a newer version of gcc, and not use the Sunfreeware package.

thanks for the research info below.

Regards,
Steve Romero